# evennia.objects.objects

This module defines the basic DefaultObject and its children DefaultCharacter, DefaultAccount, DefaultRoom and DefaultExit. These are the (default) starting points for all in-game visible entities.

This is the v1.0 develop version (for ref in doc building).

class `evennia.objects.objects.``ObjectSessionHandler`(obj)

  Bases: `object`

  Handles the get/setting of the sessid comma-separated integer field

  `__init__`(obj)

    Initializes the handler.

    Parameters

      obj (Object) – The object on which the handler is defined.

  `get`(sessid=None)

    Get the sessions linked to this Object.

    Parameters

      sessid (int, optional) – A specific session id.

    Returns

      sessions (list) –

      The sessions connected to this object. If sessid is given,

        this is a list of one (or zero) elements.

    Notes

    Aliased to self.all().

  `all`()

    Alias to get(), returning all sessions.

    Returns

      sessions (list) – All sessions.

  `add`(session)

    Add session to handler.

    Parameters

      session (Session or int) – Session or session id to add.

    Notes

    We will only add a session/sessid if this actually also exists in the the core sessionhandler.

  `remove`(session)

    Remove session from handler.

    Parameters

      session (Session or int) – Session or session id to remove.

  `clear`()

    Clear all handled sessids.

  `count`()

    Get amount of sessions connected.

    Returns

      sesslen (int) – Number of sessions handled.

class `evennia.objects.objects.``DefaultObject`(*args, **kwargs)

  Bases: `evennia.objects.models.ObjectDB`

  This is the root typeclass object, representing all entities that have an actual presence in-game. DefaultObjects generally have a location. They can also be manipulated and looked at. Game entities you define should inherit from DefaultObject at some distance.

  It is recommended to create children of this class using the evennia.create_object() function rather than to initialize the class directly - this will both set things up and efficiently save the object without obj.save() having to be called explicitly.

  `lockstring` = 'control:id({account_id}) or perm(Admin);delete:id({account_id}) or perm(Admin)'
  `objects` = <evennia.objects.manager.ObjectManager object>
  `appearance_template` = '\n{header}\n|c{name}|n\n{desc}\n{exits}{characters}{things}\n{footer}\n '
  `cmdset`
  `scripts`
  `nicks`
  `sessions`
  property `is_connected`
  property `has_account`

    Convenience property for checking if an active account is currently connected to this object.

  property `is_superuser`

    Check if user has an account, and if so, if it is a superuser.

  `contents_get`(exclude=None, content_type=None)

    Returns the contents of this object, i.e. all objects that has this object set as its location. This should be publically available.

    Parameters

      - exclude (Object) – Object to exclude from returned contents list

      - content_type (str) – A content_type to filter by. None for no filtering.

    Returns

      contents (list) – List of contents of this Object.

    Notes

    Also available as the contents property, minus exclusion and filtering.

  `contents_set`(*args)

    You cannot replace this property

  property `contents`

    Returns the contents of this object, i.e. all objects that has this object set as its location. This should be publically available.

    Parameters

      - exclude (Object) – Object to exclude from returned contents list

      - content_type (str) – A content_type to filter by. None for no filtering.

    Returns

      contents (list) – List of contents of this Object.

    Notes

    Also available as the contents property, minus exclusion and filtering.

  property `exits`

    Returns all exits from this object, i.e. all objects at this location having the property destination != None.

  `search`(searchdata, global_search=False, use_nicks=True, typeclass=None, location=None, attribute_name=None, quiet=False, exact=False, candidates=None, use_locks=True, nofound_string=None, multimatch_string=None, use_dbref=None, stacked=0)

    Returns an Object matching a search string/condition

    Perform a standard object search in the database, handling multiple results and lack thereof gracefully. By default, only objects in the current location of self or its inventory are searched for.

    Parameters

      - searchdata (str or obj) –

        Primary search criterion. Will be matched against object.key (with object.aliases second) unless the keyword attribute_name specifies otherwise.

        Special keywords:

        - #<num>: search by unique dbref. This is always a global search.

        - me,self: self-reference to this object

        - <num>-<string> - can be used to differentiate

            between multiple same-named matches. The exact form of this input is given by settings.SEARCH_MULTIMATCH_REGEX.

      - global_search (bool) – Search all objects globally. This overrules ‘location’ data.

      - use_nicks (bool) – Use nickname-replace (nicktype “object”) on searchdata.

      - typeclass (str or Typeclass, or list of either) – Limit search only to Objects with this typeclass. May be a list of typeclasses for a broader search.

      - location (Object or list) – Specify a location or multiple locations to search. Note that this is used to query the contents of a location and will not match for the location itself - if you want that, don’t set this or use candidates to specify exactly which objects should be searched. If this nor candidates are given, candidates will include caller’s inventory, current location and all objects in the current location.

      - attribute_name (str) – Define which property to search. If set, no key+alias search will be performed. This can be used to search database fields (db_ will be automatically prepended), and if that fails, it will try to return objects having Attributes with this name and value equal to searchdata. A special use is to search for “key” here if you want to do a key-search without including aliases.

      - quiet (bool) – don’t display default error messages - this tells the search method that the user wants to handle all errors themselves. It also changes the return value type, see below.

      - exact (bool) – if unset (default) - prefers to match to beginning of string rather than not matching at all. If set, requires exact matching of entire string.

      - candidates (list of objects) – this is an optional custom list of objects to search (filter) between. It is ignored if global_search is given. If not set, this list will automatically be defined to include the location, the contents of location and the caller’s contents (inventory).

      - use_locks (bool) – If True (default) - removes search results which fail the “search” lock.

      - nofound_string (str) – optional custom string for not-found error message.

      - multimatch_string (str) – optional custom string for multimatch error header.

      - use_dbref (bool or None, optional) – If True, allow to enter e.g. a query “#123” to find an object (globally) by its database-id 123. If False, the string “#123” will be treated like a normal string. If None (default), the ability to query by #dbref is turned on if self has the permission ‘Builder’ and is turned off otherwise.

      - stacked (int, optional) – If > 0, multimatches will be analyzed to determine if they only contains identical objects; these are then assumed ‘stacked’ and no multi-match error will be generated, instead stacked number of matches will be returned. If stacked is larger than number of matches, returns that number of matches. If the found stack is a mix of objects, return None and handle the multi-match error depending on the value of quiet.

    Returns

      Object, None or list – Will return an Object or None if quiet=False. Will return a list with 0, 1 or more matches if quiet=True. If stacked is a positive integer, this list may contain all stacked identical matches.

    Notes

    To find Accounts, use eg. evennia.account_search. If quiet=False, error messages will be handled by settings.SEARCH_AT_RESULT and echoed automatically (on error, return will be None). If quiet=True, the error messaging is assumed to be handled by the caller.

  `search_account`(searchdata, quiet=False)

    Simple shortcut wrapper to search for accounts, not characters.

    Parameters

      - searchdata (str) – Search criterion - the key or dbref of the account to search for. If this is “here” or “me”, search for the account connected to this object.

      - quiet (bool) – Returns the results as a list rather than echo eventual standard error messages. Default False.

    Returns

      result (Account, None or list) –

      Just what is returned depends on
        the quiet setting:

          - quiet=True: No match or multumatch auto-echoes errors to self.msg, then returns None. The esults are passed through settings.SEARCH_AT_RESULT and settings.SEARCH_AT_MULTIMATCH_INPUT. If there is a unique match, this will be returned.

          - quiet=True: No automatic error messaging is done, and what is returned is always a list with 0, 1 or more matching Accounts.

  `execute_cmd`(raw_string, session=None, **kwargs)

    Do something as this object. This is never called normally, it’s only used when wanting specifically to let an object be the caller of a command. It makes use of nicks of eventual connected accounts as well.

    Parameters

      - raw_string (string) – Raw command input

      - session (Session, optional) – Session to return results to

    Keyword Arguments

      - keyword arguments will be added to the found command (Other) –

      - instace as variables before it executes. This is (object) –

      - by default Evennia but may be used to set flags and (unused) –

      - operating paramaters for commands at run-time. (change) –

    Returns

      defer (Deferred) –

      This is an asynchronous Twisted object that

        will not fire until the command has actually finished executing. To overload this one needs to attach callback functions to it, with addCallback(function). This function will be called with an eventual return value from the command execution. This return is not used at all by Evennia by default, but might be useful for coders intending to implement some sort of nested command structure.

  `msg`(text=None, from_obj=None, session=None, options=None, **kwargs)

    Emits something to a session attached to the object.

    Parameters

      - text (str or tuple, optional) – The message to send. This is treated internally like any send-command, so its value can be a tuple if sending multiple arguments to the text oob command.

      - from_obj (obj or list, optional) – object that is sending. If given, at_msg_send will be called. This value will be passed on to the protocol. If iterable, will execute hook on all entities in it.

      - session (Session or list, optional) – Session or list of Sessions to relay data to, if any. If set, will force send to these sessions. If unset, who receives the message depends on the MULTISESSION_MODE.

      - options (dict, optional) – Message-specific option-value pairs. These will be applied at the protocol level.

    Keyword Arguments

      any (string or tuples) – All kwarg keys not listed above will be treated as send-command names and their arguments (which can be a string or a tuple).

    Notes

    at_msg_receive will be called on this Object. All extra kwargs will be passed on to the protocol.

  `for_contents`(func, exclude=None, **kwargs)

    Runs a function on every object contained within this one.

    Parameters

      - func (callable) – Function to call. This must have the formal call sign func(obj, kwargs), where obj is the object currently being processed and ****kwargs are passed on from the call to for_contents.

      - exclude (list, optional) – A list of object not to call the function on.

    Keyword Arguments

      arguments will be passed to the function for all objects. (Keyword) –

  `msg_contents`(text=None, exclude=None, from_obj=None, mapping=None, raise_funcparse_errors=False, **kwargs)

    Emits a message to all objects inside this object.

    Parameters

      - text (str or tuple) – Message to send. If a tuple, this should be on the valid OOB outmessage form (message, {kwargs}), where kwargs are optional data passed to the text outputfunc. The message will be parsed for {key} formatting and $You/$you()/$You(), $obj(name), $conj(verb) and $pron(pronoun, option) inline function callables. The name is taken from the mapping kwarg {“name”: object, …}**. The mapping[key].get_display_name(looker=recipient) will be called for that key for every recipient of the string.

      - exclude (list, optional) – A list of objects not to send to.

      - from_obj (Object, optional) – An object designated as the “sender” of the message. See DefaultObject.msg() for more info.

      - mapping (dict, optional) – A mapping of formatting keys {“key”:<object>, “key2”:<object2>,…}. The keys must either match **{key} or $You(key)/$you(key) markers in the text string. If <object> doesn’t have a get_display_name method, it will be returned as a string. If not set, a key you will be auto-added to point to from_obj if given, otherwise to self.

      - raise_funcparse_errors (bool, optional) – If set, a failing $func() will lead to an outright error. If unset (default), the failing $func() will instead appear in output unparsed.

      - **kwargs – Keyword arguments will be passed on to obj.msg() for all messaged objects.

    Notes

    For ‘actor-stance’ reporting (You say/Name says), use the $You()/$you()/$You(key) and $conj(verb) (verb-conjugation) inline callables. This will use the respective get_display_name() for all onlookers except for from_obj or self, which will become ‘You/you’. If you use $You/you(key), the key must be in mapping.

    For ‘director-stance’ reporting (Name says/Name says), use {key} syntax directly. For both {key} and You/you(key), mapping[key].get_display_name(looker=recipient) may be called depending on who the recipient is.

    Examples

    Let’s assume - player1.key -> “Player1”,

    > player1.get_display_name(looker=player2) -> “The First girl”

    - player2.key -> “Player2”, player2.get_display_name(looker=player1) -> “The Second girl”

    Actor-stance:

        char.location.msg_contents(
            "$You() $conj(attack) $you(defender).",
            mapping={"defender": player2})

    - player1 will see You attack The Second girl.

    - player2 will see ‘The First girl attacks you.’

    Director-stance:

        char.location.msg_contents(
            "{attacker} attacks {defender}.",
            mapping={"attacker:player1, "defender":player2})

    - player1 will see: ‘Player1 attacks The Second girl.’

    - player2 will see: ‘The First girl attacks Player2’

  `move_to`(destination, quiet=False, emit_to_obj=None, use_destination=True, to_none=False, move_hooks=True, move_type='move', **kwargs)

    Moves this object to a new location.

    Parameters

      - destination (Object) – Reference to the object to move to. This can also be an exit object, in which case the destination property is used as destination.

      - quiet (bool) – If true, turn off the calling of the emit hooks (announce_move_to/from etc)

      - emit_to_obj (Object) – object to receive error messages

      - use_destination (bool) – Default is for objects to use the “destination” property of destinations as the target to move to. Turning off this keyword allows objects to move “inside” exit objects.

      - to_none (bool) – Allow destination to be None. Note that no hooks are run when moving to a None location. If you want to run hooks, run them manually (and make sure they can manage None locations).

      - move_hooks (bool) – If False, turn off the calling of move-related hooks (at_pre/post_move etc) with quiet=True, this is as quiet a move as can be done.

      - move_type (str) – The “kind of move” being performed, such as “teleport”, “traverse”, “get”, “give”, or “drop”. The value can be arbitrary. By default, it only affects the text message generated by announce_move_to and announce_move_from by defining their {“type”: move_type} for outgoing text. This can be used for altering messages and/or overloaded hook behaviors.

    Keyword Arguments

      - on to announce_move_to and announce_move_from hooks. (Passed) –

      - will set the "exit_obj" kwarg to themselves. (Exits) –

    Returns

      result (bool) –

      True/False depending on if there were problems with the move.

        This method may also return various error messages to the emit_to_obj.

    Notes

    No access checks are done in this method, these should be handled before calling move_to.

    The DefaultObject hooks called (if move_hooks=True) are, in order:

    > 1. self.at_pre_move(destination) (abort if return False)

    > 2. source_location.at_pre_object_leave(self, destination) (abort if return False)

    > 3. destination.at_pre_object_receive(self, source_location) (abort if return False)

    > 4. source_location.at_object_leave(self, destination)

    > 5. self.announce_move_from(destination)

    > 6. (move happens here)

    > 7. self.announce_move_to(source_location)

    > 8. destination.at_object_receive(self, source_location)

    > 9. self.at_post_move(source_location)

  `clear_exits`()

    Destroys all of the exits and any exits pointing to this object as a destination.

  `clear_contents`()

    Moves all objects (accounts/things) to their home location or to default home.

  classmethod `create`(key, account=None, **kwargs)

    Creates a basic object with default parameters, unless otherwise specified or extended.

    Provides a friendlier interface to the utils.create_object() function.

    Parameters

      - key (str) – Name of the new object.

      - account (Account) – Account to attribute this object to.

    Keyword Arguments

      - description (str) – Brief description for this object.

      - ip (str) – IP address of creator (for object auditing).

    Returns

      object (Object) – A newly created object of the given typeclass. errors (list): A list of errors in string form, if any.

  `copy`(new_key=None, **kwargs)

    Makes an identical copy of this object, identical except for a new dbref in the database. If you want to customize the copy by changing some settings, use ObjectDB.object.copy_object() directly.

    Parameters

      new_key (string) – New key/name of copied object. If new_key is not specified, the copy will be named <old_key>_copy by default.

    Returns

      copy (Object) – A copy of this object.

  `at_object_post_copy`(new_obj, **kwargs)

    Called by DefaultObject.copy(). Meant to be overloaded. In case there’s extra data not covered by .copy(), this can be used to deal with it.

    Parameters

      new_obj (Object) – The new Copy of this object.

    Returns

      None

  `delete`()

    Deletes this object. Before deletion, this method makes sure to move all contained objects to their respective home locations, as well as clean up all exits to/from the object.

    Returns

      noerror (bool) –

      Returns whether or not the delete completed

        successfully or not.

  `access`(accessing_obj, access_type='read', default=False, no_superuser_bypass=False, **kwargs)

    Determines if another object has permission to access this object in whatever way.

    Parameters

      - accessing_obj (Object) – Object trying to access this one.

      - access_type (str, optional) – Type of access sought.

      - default (bool, optional) – What to return if no lock of access_type was found.

      - no_superuser_bypass (bool, optional) – If True, don’t skip lock check for superuser (be careful with this one).

    Keyword Arguments

      on to the at_access hook along with the result of the access check. (Passed) –

  `get_display_name`(looker=None, **kwargs)

    Displays the name of the object in a viewer-aware manner.

    Parameters

      looker (TypedObject) – The object or account that is looking at/getting inforamtion for this object. If not given, .name will be returned, which can in turn be used to display colored data.

    Returns

      str –

      A name to display for this object. This can contain color codes and may

        be customized based on looker. By default this contains the .key of the object, followed by the DBREF if this user is privileged to control said object.

    Notes

    This function could be extended to change how object names appear to users in character, but be wary. This function does not change an object’s keys or aliases when searching, and is expected to produce something useful for builders.

  `get_numbered_name`(count, looker, **kwargs)

    Return the numbered (singular, plural) forms of this object’s key. This is by default called by return_appearance and is used for grouping multiple same-named of this object. Note that this will be called on every member of a group even though the plural name will be only shown once. Also the singular display version, such as ‘an apple’, ‘a tree’ is determined from this method.

    Parameters

      - count (int) – Number of objects of this type

      - looker (Object) – Onlooker. Not used by default.

    Keyword Arguments

      key (str) – Optional key to pluralize, if given, use this instead of the object’s key.

    Returns

      tuple –

      This is a tuple (str, str) with the singular and plural forms of the key

        including the count.

    Examples

    ::

      obj.get_numbered_name(3, looker, key=”foo”) -> (“a foo”, “three foos”)

  `get_display_header`(looker, **kwargs)

    Get the ‘header’ component of the object description. Called by return_appearance.

    Parameters

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The header display string.

  `get_display_desc`(looker, **kwargs)

    Get the ‘desc’ component of the object description. Called by return_appearance.

    Parameters

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The desc display string..

  `get_display_exits`(looker, **kwargs)

    Get the ‘exits’ component of the object description. Called by return_appearance.

    Parameters

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The exits display data.

  `get_display_characters`(looker, **kwargs)

    Get the ‘characters’ component of the object description. Called by return_appearance.

    Parameters

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The character display data.

  `get_display_things`(looker, **kwargs)

    Get the ‘things’ component of the object description. Called by return_appearance.

    Parameters

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The things display data.

  `get_display_footer`(looker, **kwargs)

    Get the ‘footer’ component of the object description. Called by return_appearance.

    Parameters

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The footer display string.

  `format_appearance`(appearance, looker, **kwargs)

    Final processing of the entire appearance string. Called by return_appearance.

    Parameters

      - appearance (str) – The compiled appearance string.

      - looker (Object) – Object doing the looking.

      - **kwargs – Arbitrary data for use when overriding.

    Returns

      str – The final formatted output.

  `return_appearance`(looker, **kwargs)

    Main callback used by ‘look’ for the object to describe itself. This formats a description. By default, this looks for the appearance_template string set on this class and populates it with formatting keys

    > ‘name’, ‘desc’, ‘exits’, ‘characters’, ‘things’ as well as (currently empty) ‘header’/’footer’. Each of these values are retrieved by a matching method .get_display_*, such as get_display_name, get_display_footer etc.

    Parameters

      - looker (Object) – Object doing the looking. Passed into all helper methods.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call. This is passed into all helper methods.

    Returns

      str –

      The description of this entity. By default this includes

        the entity’s name, description and any contents inside it.

    Notes

    To simply change the layout of how the object displays itself (like adding some line decorations or change colors of different sections), you can simply edit .appearance_template. You only need to override this method (and/or its helpers) if you want to change what is passed into the template or want the most control over output.

  `at_first_save`()

    This is called by the typeclass system whenever an instance of this class is saved for the first time. It is a generic hook for calling the startup hooks for the various game entities. When overloading you generally don’t overload this but overload the hooks called by this method.

  `basetype_setup`()

    This sets up the default properties of an Object, just before the more general at_object_creation.

    You normally don’t need to change this unless you change some fundamental things like names of permission groups.

  `basetype_posthook_setup`()

    Called once, after basetype_setup and at_object_creation. This should generally not be overloaded unless you are redefining how a room/exit/object works. It allows for basetype-like setup after the object is created. An example of this is EXITs, who need to know keys, aliases, locks etc to set up their exit-cmdsets.

  `at_object_creation`()

    Called once, when this object is first created. This is the normal hook to overload for most object types.

  `at_object_delete`()

    Called just before the database object is persistently delete()d from the database. If this method returns False, deletion is aborted.

  `at_init`()

    This is always called whenever this object is initiated – that is, whenever it its typeclass is cached from memory. This happens on-demand first time the object is used or activated in some way after being created but also after each server restart or reload.

  `at_cmdset_get`(**kwargs)

    Called just before cmdsets on this object are requested by the command handler. If changes need to be done on the fly to the cmdset before passing them on to the cmdhandler, this is the place to do it. This is called also if the object currently have no cmdsets.

    Keyword Arguments

      caller (Session, Object or Account) – The caller requesting this cmdset.

  `at_pre_puppet`(account, session=None, **kwargs)

    Called just before an Account connects to this object to puppet it.

    Parameters

      - account (Account) – This is the connecting account.

      - session (Session) – Session controlling the connection.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_post_puppet`(**kwargs)

    Called just after puppeting has been completed and all Account<->Object links have been established.

    Parameters

      **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Note

    You can use self.account and self.sessions.get() to get account and sessions at this point; the last entry in the list from self.sessions.get() is the latest Session puppeting this Object.

  `at_pre_unpuppet`(**kwargs)

    Called just before beginning to un-connect a puppeting from this Account.

    Parameters

      **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Note

    You can use self.account and self.sessions.get() to get account and sessions at this point; the last entry in the list from self.sessions.get() is the latest Session puppeting this Object.

  `at_post_unpuppet`(account, session=None, **kwargs)

    Called just after the Account successfully disconnected from this object, severing all connections.

    Parameters

      - account (Account) – The account object that just disconnected from this object.

      - session (Session) – Session id controlling the connection that just disconnected.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_server_reload`()

    This hook is called whenever the server is shutting down for restart/reboot. If you want to, for example, save non-persistent properties across a restart, this is the place to do it.

  `at_server_shutdown`()

    This hook is called whenever the server is shutting down fully (i.e. not for a restart).

  `at_access`(result, accessing_obj, access_type, **kwargs)

    This is called with the result of an access call, along with any kwargs used for that call. The return of this method does not affect the result of the lock check. It can be used e.g. to customize error messages in a central location or other effects based on the access result.

    Parameters

      - result (bool) – The outcome of the access call.

      - accessing_obj (Object or Account) – The entity trying to gain access.

      - access_type (str) – The type of access that was requested.

    Keyword Arguments

      - used by default, added for possible expandability in a (Not) –

      - game. –

  `at_pre_move`(destination, move_type='move', **kwargs)

    Called just before starting to move this object to destination. Return False to abort move.

    Parameters

      - destination (Object) – The object we are moving to

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      bool – If we should move or not.

    Notes

    If this method returns False/None, the move is cancelled before it is even started.

  `at_pre_object_leave`(leaving_object, destination, **kwargs)

    Called just before this object is about lose an object that was previously ‘inside’ it. Return False to abort move.

    Parameters

      - leaving_object (Object) – The object that is about to leave.

      - destination (Object) – Where object is going to.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      bool – If leaving_object should be allowed to leave or not.

    Notes: If this method returns False, None, the move is canceled before

      it even started.

  `at_pre_object_receive`(arriving_object, source_location, **kwargs)

    Called just before this object received another object. If this method returns False, the move is aborted and the moved entity remains where it was.

    Parameters

      - arriving_object (Object) – The object moved into this one

      - source_location (Object) – Where moved_object came from. Note that this could be None.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      bool – If False, abort move and moved_obj remains where it was.

    Notes: If this method returns False, None, the move is canceled before

      it even started.

  `at_before_move`(destination, move_type='move', **kwargs)

    Called just before starting to move this object to destination. Return False to abort move.

    Parameters

      - destination (Object) – The object we are moving to

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      bool – If we should move or not.

    Notes

    If this method returns False/None, the move is cancelled before it is even started.

  `announce_move_from`(destination, msg=None, mapping=None, move_type='move', **kwargs)

    Called if the move is to be announced. This is called while we are still standing in the old location.

    Parameters

      - destination (Object) – The place we are going to.

      - msg (str, optional) – a replacement message.

      - mapping (dict, optional) – additional mapping objects.

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    You can override this method and call its parent with a message to simply change the default message. In the string, you can use the following as mappings (between braces):

    > object: the object which is moving. exit: the exit from which the object is moving (if found). origin: the location of the object before the move. destination: the location of the object after moving.

  `announce_move_to`(source_location, msg=None, mapping=None, move_type='move', **kwargs)

    Called after the move if the move was not quiet. At this point we are standing in the new location.

    Parameters

      - source_location (Object) – The place we came from

      - msg (str, optional) – the replacement message if location.

      - mapping (dict, optional) – additional mapping objects.

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    You can override this method and call its parent with a message to simply change the default message. In the string, you can use the following as mappings (between braces):

    > object: the object which is moving. exit: the exit from which the object is moving (if found). origin: the location of the object before the move. destination: the location of the object after moving.

  `at_post_move`(source_location, move_type='move', **kwargs)

    Called after move has completed, regardless of quiet mode or not. Allows changes to the object due to the location it is now in.

    Parameters

      - source_location (Object) – Where we came from. This may be None.

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_after_move`(source_location, move_type='move', **kwargs)

    Called after move has completed, regardless of quiet mode or not. Allows changes to the object due to the location it is now in.

    Parameters

      - source_location (Object) – Where we came from. This may be None.

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_object_leave`(moved_obj, target_location, move_type='move', **kwargs)

    Called just before an object leaves from inside this object

    Parameters

      - moved_obj (Object) – The object leaving

      - target_location (Object) – Where moved_obj is going.

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_object_receive`(moved_obj, source_location, move_type='move', **kwargs)

    Called after an object has been moved into this object.

    Parameters

      - moved_obj (Object) – The object moved into this one

      - source_location (Object) – Where moved_object came from. Note that this could be None.

      - move_type (str) – The type of move. “give”, “traverse”, etc. This is an arbitrary string provided to obj.move_to(). Useful for altering messages or altering logic depending on the kind of movement.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_traverse`(traversing_object, target_location, **kwargs)

    This hook is responsible for handling the actual traversal, normally by calling traversing_object.move_to(target_location). It is normally only implemented by Exit objects. If it returns False (usually because move_to returned False), at_post_traverse below should not be called and instead at_failed_traverse should be called.

    Parameters

      - traversing_object (Object) – Object traversing us.

      - target_location (Object) – Where target is going.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_post_traverse`(traversing_object, source_location, **kwargs)

    Called just after an object successfully used this object to traverse to another object (i.e. this object is a type of Exit)

    Parameters

      - traversing_object (Object) – The object traversing us.

      - source_location (Object) – Where traversing_object came from.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    The target location should normally be available as self.destination.

  `at_after_traverse`(traversing_object, source_location, **kwargs)

    Called just after an object successfully used this object to traverse to another object (i.e. this object is a type of Exit)

    Parameters

      - traversing_object (Object) – The object traversing us.

      - source_location (Object) – Where traversing_object came from.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    The target location should normally be available as self.destination.

  `at_failed_traverse`(traversing_object, **kwargs)

    This is called if an object fails to traverse this object for some reason.

    Parameters

      - traversing_object (Object) – The object that failed traversing us.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    Using the default exits, this hook will not be called if an Attribute err_traverse is defined - this will in that case be read for an error string instead.

  `at_msg_receive`(text=None, from_obj=None, **kwargs)

    This hook is called whenever someone sends a message to this object using the msg method.

    Note that from_obj may be None if the sender did not include itself as an argument to the obj.msg() call - so you have to check for this. .

    Consider this a pre-processing method before msg is passed on to the user session. If this method returns False, the msg will not be passed on.

    Parameters

      - text (str, optional) – The message received.

      - from_obj (any, optional) – The object sending the message.

    Keyword Arguments

      includes any keywords sent to the msg method. (This) –

    Returns

      receive (bool) – If this message should be received.

    Notes

    If this method returns False, the msg operation will abort without sending the message.

  `at_msg_send`(text=None, to_obj=None, **kwargs)

    This is a hook that is called when this object sends a message to another object with obj.msg(text, to_obj=obj).

    Parameters

      - text (str, optional) – Text to send.

      - to_obj (any, optional) – The object to send to.

    Keyword Arguments

      passed from msg() (Keywords) –

    Notes

    Since this method is executed by from_obj, if no from_obj was passed to DefaultCharacter.msg this hook will never get called.

  `get_visible_contents`(looker, **kwargs)

    Get all contents of this object that a looker can see (whatever that means, by default it checks the ‘view’ and ‘search’ locks), grouped by type. Helper method to return_appearance.

    Parameters

      - looker (Object) – The entity looking.

      - **kwargs (any) – Passed from return_appearance. Unused by default.

    Returns

      dict –

      A dict of lists categorized by type. Byt default this

        contains ‘exits’, ‘characters’ and ‘things’. The elements of these lists are the actual objects.

  `get_content_names`(looker, **kwargs)

    Get the proper names for all contents of this object. Helper method for return_appearance.

    Parameters

      - looker (Object) – The entity looking.

      - **kwargs (any) – Passed from return_appearance. Passed into get_display_name for each found entity.

    Returns

      dict –

      A dict of lists categorized by type. Byt default this

        contains ‘exits’, ‘characters’ and ‘things’. The elements of these lists are strings - names of the objects that can depend on the looker and also be grouped in the case of multiple same-named things etc.

    Notes

    This method shouldn’t add extra coloring to the names beyond what is already given by the .get_display_name() (and the .name field) already. Per-type coloring can be applied in return_apperance.

  `at_look`(target, **kwargs)

    Called when this object performs a look. It allows to customize just what this means. It will not itself send any data.

    Parameters

      - target (Object) – The target being looked at. This is commonly an object or the current location. It will be checked for the “view” type access.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call. This will be passed into return_appearance, get_display_name and at_desc but is not used by default.

    Returns

      lookstring (str) –

      A ready-processed look string

        potentially ready to return to the looker.

  `at_desc`(looker=None, **kwargs)

    This is called whenever someone looks at this object.

    Parameters

      - looker (Object, optional) – The object requesting the description.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_pre_get`(getter, **kwargs)

    Called by the default get command before this object has been picked up.

    Parameters

      - getter (Object) – The object about to get this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      shouldget (bool) – If the object should be gotten or not.

    Notes

    If this method returns False/None, the getting is cancelled before it is even started.

  `at_before_get`(getter, **kwargs)

    Called by the default get command before this object has been picked up.

    Parameters

      - getter (Object) – The object about to get this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      shouldget (bool) – If the object should be gotten or not.

    Notes

    If this method returns False/None, the getting is cancelled before it is even started.

  `at_get`(getter, **kwargs)

    Called by the default get command when this object has been picked up.

    Parameters

      - getter (Object) – The object getting this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    This hook cannot stop the pickup from happening. Use permissions or the at_pre_get() hook for that.

  `at_pre_give`(giver, getter, **kwargs)

    Called by the default give command before this object has been given.

    Parameters

      - giver (Object) – The object about to give this object.

      - getter (Object) – The object about to get this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      shouldgive (bool) – If the object should be given or not.

    Notes

    If this method returns False/None, the giving is cancelled before it is even started.

  `at_before_give`(giver, getter, **kwargs)

    Called by the default give command before this object has been given.

    Parameters

      - giver (Object) – The object about to give this object.

      - getter (Object) – The object about to get this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      shouldgive (bool) – If the object should be given or not.

    Notes

    If this method returns False/None, the giving is cancelled before it is even started.

  `at_give`(giver, getter, **kwargs)

    Called by the default give command when this object has been given.

    Parameters

      - giver (Object) – The object giving this object.

      - getter (Object) – The object getting this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    This hook cannot stop the give from happening. Use permissions or the at_pre_give() hook for that.

  `at_pre_drop`(dropper, **kwargs)

    Called by the default drop command before this object has been dropped.

    Parameters

      - dropper (Object) – The object which will drop this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      shoulddrop (bool) – If the object should be dropped or not.

    Notes

    If this method returns False/None, the dropping is cancelled before it is even started.

  `at_before_drop`(dropper, **kwargs)

    Called by the default drop command before this object has been dropped.

    Parameters

      - dropper (Object) – The object which will drop this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      shoulddrop (bool) – If the object should be dropped or not.

    Notes

    If this method returns False/None, the dropping is cancelled before it is even started.

  `at_drop`(dropper, **kwargs)

    Called by the default drop command when this object has been dropped.

    Parameters

      - dropper (Object) – The object which just dropped this object.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    This hook cannot stop the drop from happening. Use permissions or the at_pre_drop() hook for that.

  `at_pre_say`(message, **kwargs)

    Before the object says something.

    This hook is by default used by the ‘say’ and ‘whisper’ commands as used by this command it is called before the text is said/whispered and can be used to customize the outgoing text from the object. Returning None aborts the command.

    Parameters

      message (str) – The suggested say/whisper text spoken by self.

    Keyword Arguments

      - whisper (bool) – If True, this is a whisper rather than a say. This is sent by the whisper command by default. Other verbal commands could use this hook in similar ways.

      - receivers (Object or iterable) – If set, this is the target or targets for the say/whisper.

    Returns

      message (str) – The (possibly modified) text to be spoken.

  `at_before_say`(message, **kwargs)

    Before the object says something.

    This hook is by default used by the ‘say’ and ‘whisper’ commands as used by this command it is called before the text is said/whispered and can be used to customize the outgoing text from the object. Returning None aborts the command.

    Parameters

      message (str) – The suggested say/whisper text spoken by self.

    Keyword Arguments

      - whisper (bool) – If True, this is a whisper rather than a say. This is sent by the whisper command by default. Other verbal commands could use this hook in similar ways.

      - receivers (Object or iterable) – If set, this is the target or targets for the say/whisper.

    Returns

      message (str) – The (possibly modified) text to be spoken.

  `at_say`(message, msg_self=None, msg_location=None, receivers=None, msg_receivers=None, **kwargs)

    Display the actual say (or whisper) of self.

    This hook should display the actual say/whisper of the object in its location. It should both alert the object (self) and its location that some text is spoken. The overriding of messages or mapping allows for simple customization of the hook without re-writing it completely.

    Parameters

      - message (str) – The message to convey.

      - msg_self (bool or str, optional) – If boolean True, echo message to self. If a string, return that message. If False or unset, don’t echo to self.

      - msg_location (str, optional) – The message to echo to self’s location.

      - receivers (Object or iterable, optional) – An eventual receiver or receivers of the message (by default only used by whispers).

      - msg_receivers (str) – Specific message to pass to the receiver(s). This will parsed with the {receiver} placeholder replaced with the given receiver.

    Keyword Arguments

      - whisper (bool) – If this is a whisper rather than a say. Kwargs can be used by other verbal commands in a similar way.

      - mapping (dict) – Pass an additional mapping to the message.

    Notes

    Messages can contain {} markers. These are substituted against the values passed in the mapping argument.

    > msg_self = ‘You say: “{speech}”’ msg_location = ‘{object} says: “{speech}”’ msg_receivers = ‘{object} whispers: “{speech}”’

    Supported markers by default:

      {self}: text to self-reference with (default ‘You’) {speech}: the text spoken/whispered by self. {object}: the object speaking. {receiver}: replaced with a single receiver only for strings meant for a specific

      > receiver (otherwise ‘None’).

      {all_receivers}: comma-separated list of all receivers,

        if more than one, otherwise same as receiver

      {location}: the location where object is.

  exception `DoesNotExist`

    Bases: `evennia.objects.models.ObjectDB.DoesNotExist`

  exception `MultipleObjectsReturned`

    Bases: `evennia.objects.models.ObjectDB.MultipleObjectsReturned`

  `path` = 'evennia.objects.objects.DefaultObject'
  `typename` = 'DefaultObject'

class `evennia.objects.objects.``DefaultCharacter`(*args, **kwargs)

  Bases: `evennia.objects.objects.DefaultObject`

  This implements an Object puppeted by a Session - that is, a character avatar controlled by an account.

  `lockstring` = 'puppet:id({character_id}) or pid({account_id}) or perm(Developer) or pperm(Developer);delete:id({account_id}) or perm(Admin);edit:pid({account_id}) or perm(Admin)'
  classmethod `create`(key, account=None, **kwargs)

    Creates a basic Character with default parameters, unless otherwise specified or extended.

    Provides a friendlier interface to the utils.create_character() function.

    Parameters

      - key (str) – Name of the new Character.

      - account (obj, optional) – Account to associate this Character with. If unset supplying None– it will change the default lockset and skip creator attribution.

    Keyword Arguments

      - description (str) – Brief description for this object.

      - ip (str) – IP address of creator (for object auditing).

      - other kwargs will be passed into the create_object call. (All) –

    Returns

      tuple – (new_character, errors). On error, the new_character is None and errors is a list of error strings (an empty list otherwise).

  classmethod `normalize_name`(name)

    Normalize the character name prior to creating. Note that this should be refactored to support i18n for non-latin scripts, but as we (currently) have no bug reports requesting better support of non-latin character sets, requiring character names to be latinified is an acceptable option.

    Parameters

      name (str) – The name of the character

    Returns

      latin_name (str) – A valid name.

  classmethod `validate_name`(name)

    Validate the character name prior to creating. Overload this function to add custom validators

    Parameters

      name (str) – The name of the character

    Returns

      valid (bool) – True if character creation should continue; False if it should fail

  `basetype_setup`()

    Setup character-specific security.

    You should normally not need to overload this, but if you do, make sure to reproduce at least the two last commands in this method (unless you want to fundamentally change how a Character object works).

  `at_post_move`(source_location, move_type='move', **kwargs)

    We make sure to look around after a move.

  `at_after_move`(source_location, move_type='move', **kwargs)

    We make sure to look around after a move.

  `at_pre_puppet`(account, session=None, **kwargs)

    Return the character from storage in None location in at_post_unpuppet. :param account: This is the connecting account. :type account: Account :param session: Session controlling the connection. :type session: Session

  `at_post_puppet`(**kwargs)

    Called just after puppeting has been completed and all Account<->Object links have been established.

    Parameters

      **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Note

    You can use self.account and self.sessions.get() to get account and sessions at this point; the last entry in the list from self.sessions.get() is the latest Session puppeting this Object.

  `at_post_unpuppet`(account, session=None, **kwargs)

    We stove away the character when the account goes ooc/logs off, otherwise the character object will remain in the room also after the account logged off (“headless”, so to say).

    Parameters

      - account (Account) – The account object that just disconnected from this object.

      - session (Session) – Session controlling the connection that just disconnected.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  property `idle_time`

    Returns the idle time of the least idle session in seconds. If no sessions are connected it returns nothing.

  property `connection_time`

    Returns the maximum connection time of all connected sessions in seconds. Returns nothing if there are no sessions.

  exception `DoesNotExist`

    Bases: `evennia.objects.objects.DefaultObject.DoesNotExist`

  exception `MultipleObjectsReturned`

    Bases: `evennia.objects.objects.DefaultObject.MultipleObjectsReturned`

  `path` = 'evennia.objects.objects.DefaultCharacter'
  `typename` = 'DefaultCharacter'

class `evennia.objects.objects.``DefaultRoom`(*args, **kwargs)

  Bases: `evennia.objects.objects.DefaultObject`

  This is the base room object. It’s just like any Object except its location is always None.

  `lockstring` = 'control:id({id}) or perm(Admin); delete:id({id}) or perm(Admin); edit:id({id}) or perm(Admin)'
  classmethod `create`(key, account=None, **kwargs)

    Creates a basic Room with default parameters, unless otherwise specified or extended.

    Provides a friendlier interface to the utils.create_object() function.

    Parameters

      - key (str) – Name of the new Room.

      - account (obj, optional) – Account to associate this Room with. If given, it will be given specific control/edit permissions to this object (along with normal Admin perms). If not given, default

    Keyword Arguments

      - description (str) – Brief description for this object.

      - ip (str) – IP address of creator (for object auditing).

    Returns

      room (Object) – A newly created Room of the given typeclass. errors (list): A list of errors in string form, if any.

  `basetype_setup`()

    Simple room setup setting locks to make sure the room cannot be picked up.

  exception `DoesNotExist`

    Bases: `evennia.objects.objects.DefaultObject.DoesNotExist`

  exception `MultipleObjectsReturned`

    Bases: `evennia.objects.objects.DefaultObject.MultipleObjectsReturned`

  `path` = 'evennia.objects.objects.DefaultRoom'
  `typename` = 'DefaultRoom'

class `evennia.objects.objects.``ExitCommand`(**kwargs)

  Bases: `evennia.commands.default.muxcommand.MuxCommand`

  This is a command that simply cause the caller to traverse the object it is attached to.

  `obj` = None
  `func`()

    Default exit traverse if no syscommand is defined.

  `get_extra_info`(caller, **kwargs)

    Shows a bit of information on where the exit leads.

    Parameters

      - caller (Object) – The object (usually a character) that entered an ambiguous command.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Returns

      A string with identifying information to disambiguate the command, conventionally with a preceding space.

  `aliases` = []
  `help_category` = 'general'
  `key` = 'command'
  `lock_storage` = 'cmd:all();'
  `search_index_entry` = {'aliases': '', 'category': 'general', 'key': 'command', 'no_prefix': ' ', 'tags': '', 'text': '\n This is a command that simply cause the caller to traverse\n the object it is attached to.\n\n '}

class `evennia.objects.objects.``DefaultExit`(*args, **kwargs)

  Bases: `evennia.objects.objects.DefaultObject`

  This is the base exit object - it connects a location to another. This is done by the exit assigning a “command” on itself with the same name as the exit object (to do this we need to remember to re-create the command when the object is cached since it must be created dynamically depending on what the exit is called). This command (which has a high priority) will thus allow us to traverse exits simply by giving the exit-object’s name on its own.

  `exit_command`

    alias of `ExitCommand`

  `priority` = 101
  `lockstring` = 'control:id({id}) or perm(Admin); delete:id({id}) or perm(Admin); edit:id({id}) or perm(Admin)'
  `create_exit_cmdset`(exidbobj)

    Helper function for creating an exit command set + command.

    The command of this cmdset has the same name as the Exit object and allows the exit to react when the account enter the exit’s name, triggering the movement between rooms.

    Parameters

      exidbobj (Object) – The DefaultExit object to base the command on.

  classmethod `create`(key, source, dest, account=None, **kwargs)

    Creates a basic Exit with default parameters, unless otherwise specified or extended.

    Provides a friendlier interface to the utils.create_object() function.

    Parameters

      - key (str) – Name of the new Exit, as it should appear from the source room.

      - account (obj) – Account to associate this Exit with.

      - source (Room) – The room to create this exit in.

      - dest (Room) – The room to which this exit should go.

    Keyword Arguments

      - description (str) – Brief description for this object.

      - ip (str) – IP address of creator (for object auditing).

    Returns

      exit (Object) – A newly created Room of the given typeclass. errors (list): A list of errors in string form, if any.

  `basetype_setup`()

    Setup exit-security

    You should normally not need to overload this - if you do make sure you include all the functionality in this method.

  `at_cmdset_get`(**kwargs)

    Called just before cmdsets on this object are requested by the command handler. If changes need to be done on the fly to the cmdset before passing them on to the cmdhandler, this is the place to do it. This is called also if the object currently has no cmdsets.

    Keyword Arguments

      force_init (bool) – If True, force a re-build of the cmdset (for example to update aliases).

  `at_init`()

    This is called when this objects is re-loaded from cache. When that happens, we make sure to remove any old ExitCmdSet cmdset (this most commonly occurs when renaming an existing exit)

  `at_traverse`(traversing_object, target_location, **kwargs)

    This implements the actual traversal. The traverse lock has already been checked (in the Exit command) at this point.

    Parameters

      - traversing_object (Object) – Object traversing us.

      - target_location (Object) – Where target is going.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

  `at_failed_traverse`(traversing_object, **kwargs)

    Overloads the default hook to implement a simple default error message.

    Parameters

      - traversing_object (Object) – The object that failed traversing us.

      - **kwargs (dict) – Arbitrary, optional arguments for users overriding the call (unused by default).

    Notes

    Using the default exits, this hook will not be called if an Attribute err_traverse is defined - this will in that case be read for an error string instead.

  exception `DoesNotExist`

    Bases: `evennia.objects.objects.DefaultObject.DoesNotExist`

  exception `MultipleObjectsReturned`

    Bases: `evennia.objects.objects.DefaultObject.MultipleObjectsReturned`

  `path` = 'evennia.objects.objects.DefaultExit'
  `typename` = 'DefaultExit'